<template>
<div class="bg">
  <main class="list">
    <Header v-bind:title="'Parks'"/>
    <Modal
      v-if="showModal"
      @deny="denyLocation()"
      @allow="requestUsersLocation()"
    >
      <h3 slot="header">Get location</h3>
      <p slot="body">Please allow this app to use your location to show you the nearest parks.</p>
    </Modal>

    <vue-autosuggest
      v-if="doSearch"
        ref="autosuggest"
        :suggestions="filteredOptions"
        :input-props="{id:'autosuggest__input', placeholder:'Search for a park by name', ref: 'searchInput', type: 'search'}"
        @input="onSearchInputChange"
        @selected="onSelected"
        :get-suggestion-value="getSuggestionValue"
      >
        <template slot-scope="{suggestion}">
          <div class="list__container">
            <!-- <router-link :to="{path: getParkLink(suggestion.item.id)}" class="list-item"> -->
            <a :href="getParkLink(suggestion.item.id)" class="list-item">
              <div class="list-item__inner" :style="getParkPhoto(suggestion.item.id)">
                <div class="list-item__details">
                  <h3 class="list-item__header">{{ suggestion.item.siteName }}</h3>
                </div>
              </div>
            </a>
            <!-- </router-link> -->
          </div>
        </template>
      </vue-autosuggest>

      <ul class="list__container" v-if="!doSearch">
        <li v-for="park in parks" v-bind:key="park.id">
          <router-link :to="{
              path: getParkLink(park.id),
            }" class="list-item">
            <div class="list-item__inner" :style="getParkPhoto(park.id)">
              <div class="list-item__details">
                <h3 class="list-item__header">{{ park.siteName }}</h3>
                <ul class="list-item__stats-container">
                  <li class="list-item__stats">{{park.unique_trees}} Unique species</li>
                  <li class="list-item__stats">{{park.total_trees}} Total trees</li>
                </ul>
              </div>
            </div>
          </router-link>
        </li>
        <span v-if="loading" class="spinner">
          <div></div>
          <div></div>
      </span>
      <span v-if="maxDistReached">No more parks found!</span>
    </ul>

  </main>
  </div>
</template>

<script>
import Header from "./Header.vue";
import Modal from "./Modal.vue";
import { parkService } from "../services/Park.service";
import { VueAutosuggest } from "vue-autosuggest";

export default {
  name: "list",
  components: {
    Header,
    Modal,
    VueAutosuggest
  },
  data: () => {
    return {
      parks: [], // {id: string, siteName: string, total_trees: string, unique_trees: string}
      loading: true,
      page: 1,
      foundParksByLocation: false,
      maxDistReached: false,
      showModal: false,
      doSearch: true,
      filteredOptions: [],
      suggestions: null
    };
  },
  beforeMount() {
    this.showModal = false // !this.$config.locationAllowed;
  },
  async mounted() {
    // this.getParkList();
    this.suggestions = await this.$store.dispatch('parks/getParkList');
    this.$log.info(`List: mounted: ${this.suggestions.length} parks`)
    window.onscroll = () => {
      if (
        window.innerHeight + window.scrollY >= document.body.offsetHeight &&
        !this.loading
      ) {
        this.loading = true;
        this.getParks().then(() => {
          // this.loading = false;
        });
      }
    };
  },
  methods: {
    // eslint-disable-next-line
    onSearchInputChange(text, oldText) {
      if (text === null || text.length < 2) {
        this.filteredOptions = []
        /* Maybe the text is null but you wanna do
         *  something else, but don't filter by null.
         */
        return;
      }
      // Full customizability over filtering
      const filteredData = this.suggestions.filter(option => {
        return option.siteName.toLowerCase().indexOf(text.toLowerCase()) > -1;
      });
      // Store data in one property, and filtered in another
      this.filteredOptions = [{ data: filteredData }];
    },
    onSelected(sel) {
      if (sel) {
        this.$store.commit('parks/setCurrentParkId', sel.item.id)
        this.$router.push(this.getParkLink(sel.item.id));
      }
    },
    /**
     * This is what the <input/> value is set to when you are selecting a suggestion.
     */
    getSuggestionValue(suggestion) {
      return suggestion.item.siteName;
    },
    getParkLink: parkId => `park/${parkId}`,
    requestUsersLocation() {
      this.showModal = false;
      this.loading = true;
      this.$config.locationAllowed = true;
      this.parks = [];
      this.getParks();
      this.doSearch = false
      this.loading = false;
    },
    denyLocation() {
      this.showModal = false;
      this.loading = true;
      this.$config.locationAllowed = false;
      this.parks = [];
      this.getParks();
      this.doSearch = true
      this.loading = false;
    },
    async getParks() {
      if (this.$store.getters['locationAllowed']) {
        this.$getLocation().then(async coords => { // from vue-browser-geolocation
          try {
            let parks = await parkService.nearestParks(
              this.page,
              coords.lat,
              coords.lng
            );
            if (parks.length > 0) {
              this.page++;

              if (this.parks.length === parks.length) {
                this.maxDistReached = true;
              }

              this.parks = parks;
              this.foundParksByLocation = true;
            }
          } catch (error) {
            if (!this.foundParksByLocation) {
              // Location failed - no nearby parks, get parks by alpha
              this.$config.locationAllowed = false;
              let parks = await parkService.parks(1);
              this.page = 2;
              this.parks = parks;
            } else {
              // Request failed to get more parks by location, show an error
              this.maxDistReached = true;
            }
          }
        });
      } else {
        let parks = await parkService.parks(this.page);
        this.page++;
        this.parks = [...this.parks, ...parks];
      }
    },
    getParkPhoto(parkId) {
      let retval;
      try {
        let img = require(`../assets/parks/${parkId}.jpg`);
        retval = `background-image: url(${img}; background-size: cover;`;
      } catch (error) {
        retval = `background-size: 70%;`;
      }
      return retval;
    },
  }
};
</script>

<!-- scoped won't work here -->
<style lang="scss">
@import "../styles/variables.scss";
// body {
//   background: $background-color;
// }
// searchbox
#autosuggest {
  background: lighten($background-color, 20%);
  color: $primary-text-color;
  #autosuggest__input {
    border: none;
    border-bottom: 1px solid rgba(0,0,0,.12);
    display: inline-block;
    font-size: 16px;
    font-family: "Helvetica","Arial",sans-serif;
    margin: 10px 5%;
    padding: 4px 0;
    width: 90%;
    background: 0 0;
    text-align: left;
    color: inherit;
  }
}
.autosuggest__results-container {
  background: lighten($background-color, 10%);
  padding-top: 20px;
}
.result_item {
  border: 1px inset $dark-primary-color;
  padding: 5px;
}
.bg {
  height: 100%;
  width: 100%;
  background: lighten($background-color, 10%);
  background-image: url(../assets/parks/park-empty.svg);
  background-repeat: no-repeat;
  background-position: center;
  background-size: 50%;
}
.list {
  background-color: $gray-super-light;
  &__container {
    display: block;
    margin: 0 auto;
    max-width: 600px;
    padding-top: 8px;
    text-align: center;
  }
}

.list-item {
  border-radius: 3px;
  display: flex;
  height: 180px;
  max-width: 600px;
  margin: 8px;
  position: relative;
  text-decoration: none;

  &__inner {
    align-items: flex-end;
    background-image: url("../assets/parks/park-empty.svg");
    background-size: contain;
    background-repeat: no-repeat;
    border-radius: 3px;
    color: #fff;
    margin: auto;
    display: flex;
    height: 100%;
    width: 100%;
    background-position: center;
  }

  &__header {
    margin: 8px 0;
  }

  &__details {
    padding: 16px;
    text-align: left;
    z-index: 2;
  }

  &__stats-container {
    list-style-type: none;
    padding-inline-start: 0;
    text-align: left;
  }

  &__stats {
    display: inline;
    position: relative;

    &:not(:first-child) {
      padding-left: 18px;

      &:after {
        background-color: #fff;
        content: "";
        display: inline-block;
        border-radius: 20px;
        height: 6px;
        width: 6px;
        position: absolute;
        left: 6px;
        top: 8px;
      }
    }
  }

  &:before {
    background-color: $title-green;
    border-radius: 3px;
    bottom: 0;
    content: "";
    left: 0;
    opacity: 0.8;
    position: absolute;
    right: 0;
    top: 0;
    width: 100%;
    z-index: 1;
  }
}
</style>
